<script lang="ts">
import Vue from 'vue';
import { init } from 'aos';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  ComparisonHero,
  ComparisonOverview,
  ComparisonAnalysis,
  CompetitorCards,
} from '~/components/competition/index.vue';
import { NextStep } from '~/components/common/index';

import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  components: {
    ComparisonHero,
    ComparisonOverview,
    ComparisonAnalysis,
    NextStep,
    CompetitorCards,
  },
  async asyncData({ $content, params, error }: any) {
    try {
      if (params.slug === 'template') return error({ statusCode: 404 });
      const templateData = await $content(`competition/template`).fetch();
      const comparisonData = await $content(
        `competition/${params.slug}`,
      ).fetch();

      const data = {
        templateData,
        comparisonData,
      };

      return { data };
    } catch (e) {
      return error({ statusCode: 404 });
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).data.comparisonData, this.$route.path);
  },
  beforeMount() {
    init({
      once: true,
    });
  },
});
</script>

<template>
  <div>
    <ComparisonHero
      :template-data="data.templateData.hero"
      :comparison-data="data.comparisonData.hero"
    />
    <ComparisonOverview
      :template-data="data.templateData.overview"
      :comparison-data="data.comparisonData.overview"
    />
    <ComparisonAnalysis
      v-if="data.comparisonData.analysis"
      :template-data="data.templateData.analysis"
      :comparison-data="data.comparisonData.analysis"
    />
    <SlpContainer
      v-if="data.comparisonData.competitor_cards"
      variant="light-purple-100"
      class="slp-my-96"
    >
      <CompetitorCards :data="data.comparisonData.competitor_cards" />
    </SlpContainer>
    <SlpContainer class="slp-mt-96 next-steps__container" variant="gradient">
      <NextStep />
    </SlpContainer>
    <SlpTopButton data-ga-name="to-top" data-ga-location="body" />
  </div>
</template>

<style scoped lang="scss">
.slp-top-btn {
  @media (max-width: $breakpoint-md) {
    display: none;
  }
}

.next-steps__container {
  @media (max-width: $breakpoint-md) {
    margin-top: 40px;
  }
}
</style>
